<template>
  <form action="#">
    <rui-errors :errors="errors"
                :model="model" />

    <div class="_container">
      <slot />
    </div>

    <rui-actions :bottom="!fixedActions">
      <rui-button v-if="cancellable"
                  type="reset"
                  variant="canceling"
                  :disabled="loading"
                  @click="$emit('cancel')">
        {{ $t('rui.generic.cancel') }}
      </rui-button>
      <rui-submit-button :loading="loading" :caption="submitButtonTitle" :icon="submitButtonIcon" :disabled="disableSubmit" />
    </rui-actions>
  </form>
</template>

<script>
import RuiSubmitButton from '../Inputs/SubmitButton/SubmitButton.vue'
import RuiErrors from '../DataDisplay/Error/Errors.vue'
import RuiButton from '../Button/Button.vue'
import RuiActions from '../Actions/Actions.vue'

/**
 * Simple form with submit/cancel actions
 *
 * @preset Default {
 *                    "props": { "errors": {"error": "Simple error message" } },
 *                    "slots": { "default": "Form inputs content goes here.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>Actions area is sticky by default." }
 *                 }
 * @preset Complex error {
 *                    "props": { "errors": { "title": ["is missing"], "content": ["is boring", "is not long enough"] } },
 *                    "slots": { "default": "Form inputs content goes here.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>.<br>Actions area is sticky by default." }
 *                  }
 * @propsGroup I18n     [model]
 * @propsGroup Display  [fixedActions ]
 * @propsGroup Behavior [loading, cancellable ]
 * @propsGroup Buttons  [submitButtonTitle, submitButtonIcon, disableSubmit]
 * @propsGroup Content  [errors]
 */
export default {
  name: 'RuiForm',
  emits: [
    'cancel',
  ],
  components: { RuiActions, RuiButton, RuiErrors, RuiSubmitButton },
  props: {
    /** Model name to display errors */
    model: { required: false, type: String, default: null },
    /** Whether something is loading */
    loading: { required: false, type: Boolean, default: false },
    /** Errors list */
    errors: { required: false, type: Object, default: null },
    /** Custom caption for the submit button */
    submitButtonTitle: { required: false, type: String, default: null },
    /** Whether to disable the submit button (e.g.: in case of form error) */
    disableSubmit: { required: false, type: Boolean, default: false },
    /** Custom icon for the submit button */
    submitButtonIcon: { required: false, type: String, default: null },
    /** Whether to display a "Cancel" button */
    cancellable: { required: false, type: Boolean, default: true },
    /**
     * Whether to keep the actions area on the bottom of the form.
     *
     * Defaults to `false`, which makes it sticky to bottom
     */
    fixedActions: { required: false, type: Boolean, default: false },
  },
}
</script>
